<?php
/*
Simple:Press
Plupload plugin install/upgrade routine
$LastChangedDate: 2016-01-04 12:44:34 -0800 (Mon, 04 Jan 2016) $
$Rev: 13763 $
*/

if (preg_match('#'.basename(__FILE__).'#', $_SERVER['PHP_SELF'])) die('Access denied - you cannot directly call this file');

function sp_plupload_do_install() {
	$olduploads = sp_get_option('sfuploads');
	$uploads = sp_get_option('spPlupload');
	if (empty($olduploads) && empty($uploads)) {
		$sql = "
			CREATE TABLE IF NOT EXISTS ".SPPOSTATTACHMENTS." (
				attachment_id BIGINT(20) NOT NULL auto_increment,
				post_id BIGINT(20) NOT NULL,
				topic_id BIGINT(20) NOT NULL,
                type VARCHAR(10) NOT NULL,
				path VARCHAR(250) NOT NULL,
				filename VARCHAR(100) NOT NULL,
				size INT NOT NULL,
				PRIMARY KEY (attachment_id),
                KEY post_id_idx (post_id),
                KEY topic_id_idx (topic_id)
			) ".spdb_charset().";";
		spdb_query($sql);

		$tables = sp_get_option('installed_tables');
		if ($tables) {
			if (!in_array(SPPOSTATTACHMENTS, $tables)) $tables[] = SPPOSTATTACHMENTS;
			sp_update_option('installed_tables', $tables);
		}

		$uploads = array();
		$uploads['showinserted'] = true;
    	$uploads['imageinsert'] = true;
		$uploads['imgquality'] = 100;
		$uploads['thumbquality'] = 100;
		$uploads['imagetypes'] = 'jpg, jpeg, gif, png';
		$uploads['imagemaxsize'] = 51200;
		$uploads['imagemaxwidth'] = 0;
		$uploads['imagemaxheight'] = 0;
    	$uploads['imageinsert'] = true;
    	$uploads['mediainsert'] = true;
    	$uploads['fileinsert'] = false;
		$uploads['mediatypes'] = 'swf, dcr, mov, qt, mpg, mp3, mp4, mpeg, avi, wmv, wm, asf, asx, wmx, wvx, rm, ra, ram';
		$uploads['mediamaxsize'] = 0;
		$uploads['mediawidth'] = 320;
		$uploads['mediaheight'] = 240;
		$uploads['filetypes'] = 'txt, rtf, doc, pdf';
		$uploads['filemaxsize'] = 51200;
		$uploads['prohibited'] = 'php, php3, php5, js, html, htm, phtml, asp, aspx, ascx, jsp, cfm, cfc, pl, bat, exe, dll, reg, cgi, sh, py';
        $uploads['useforphotos'] = false;
        $uploads['showthumbs'] = true;
        $uploads['lang'] = 'en';

        $uploads['dbversion'] = SPPLUPDBVERSION;
		sp_add_option('spPlupload', $uploads);

		# storage location
		$basepath = 'sp-resources';
    	if (!file_exists(SF_STORE_DIR.'/'.$basepath)) {
        	$perms = fileperms(SF_STORE_DIR);
        	$owners = stat(SF_STORE_DIR);
        	if ($perms === false) $perms = 0755;
            @mkdir(SF_STORE_DIR.'/'.$basepath, $perms);
        	if (file_exists(SF_STORE_DIR.'/'.$basepath)) {
        		# Is the ownership correct?
        		$newowners = stat(SF_STORE_DIR.'/'.$basepath);
        		if ($newowners['uid'] != $owners['uid'] || $newowners['gid'] != $owners['gid']) {
        			@chown(SF_STORE_DIR.'/'.$basepath, $owners['uid']);
        			@chgrp(SF_STORE_DIR.'/'.$basepath, $owners['gid']);
        		}
        	}
        }

		$sfconfig = sp_get_option('sfconfig');
		$sfconfig['image-uploads'] = $basepath.'/forum-image-uploads';
		$sfconfig['media-uploads'] = $basepath.'/forum-media-uploads';
		$sfconfig['file-uploads'] = $basepath.'/forum-file-uploads';
		sp_update_option('sfconfig', $sfconfig);

		$newpath = SF_STORE_DIR.'/'.$sfconfig['image-uploads'];
		@mkdir($newpath, 0777);

		$newpath = SF_STORE_DIR.'/'.$sfconfig['media-uploads'];
		@mkdir($newpath, 0777);

		$newpath = SF_STORE_DIR.'/'.$sfconfig['file-uploads'];
		@mkdir($newpath, 0777);
    } elseif (empty($uploads)) { # upgrade from pre sp 5.0 when pm was in core
		$sql = "
			CREATE TABLE IF NOT EXISTS ".SPPOSTATTACHMENTS." (
				attachment_id BIGINT(20) NOT NULL auto_increment,
				post_id BIGINT(20) NOT NULL,
				topic_id BIGINT(20) NOT NULL,
                type VARCHAR(10) NOT NULL,
				path VARCHAR(250) NOT NULL,
				filename VARCHAR(100) NOT NULL,
				size INT NOT NULL,
				PRIMARY KEY (attachment_id),
                KEY post_id_idx (post_id),
                KEY topic_id_idx (topic_id)
			) ".spdb_charset().";";
		spdb_query($sql);

		$tables = sp_get_option('installed_tables');
		if ($tables) {
			if (!in_array(SPPOSTATTACHMENTS, $tables)) $tables[] = SPPOSTATTACHMENTS;
			sp_update_option('installed_tables', $tables);
		}

		$olduploads['showinserted'] = true;
    	$olduploads['imageinsert'] = true;
		$olduploads['imgquality'] = 100;
		$olduploads['thumbquality'] = 100;
		$olduploads['imagemaxwidth'] = 0;
		$olduploads['imagemaxheight'] = 0;
    	$olduploads['mediainsert'] = true;
		$olduploads['mediawidth'] = 320;
		$olduploads['mediaheight'] = 240;
        $olduploads['useforphotos'] = false;
        $olduploads['lang'] = 'en';
		sp_add_option('spPlupload', $olduploads);

		sp_delete_option('sfuploads');
    }

    # add profile tabs
    sp_profile_add_tab('Attachments', 0, 1, 'manage_attachments');
    sp_profile_add_menu('Attachments', 'Image Uploads', SPPLUPFORMSDIR.'sp-plupload-images-form.php', 0, 1, 'upload_images');
    sp_profile_add_menu('Attachments', 'Media Uploads', SPPLUPFORMSDIR.'sp-plupload-media-form.php', 0, 1, 'upload_media');
    sp_profile_add_menu('Attachments', 'File Uploads', SPPLUPFORMSDIR.'sp-plupload-files-form.php', 0, 1, 'upload_files');

    # add a new permission into the auths table
	sp_add_auth('upload_images', __('Can upload images in posts', 'sp-plup'), 1, 1, 0, 0, 8);
	sp_add_auth('upload_media', __('Can upload media in posts', 'sp-plup'), 1, 1, 0, 0, 8);
	sp_add_auth('upload_files', __('Can upload files in posts', 'sp-plup'), 1, 1, 0, 0, 8);
	sp_add_auth('upload_signatures', __('Can upload signature images', 'sp-plup'), 1, 1, 0, 0, 8);
   	sp_add_auth('download_attachments', __('Can download other file type attachments', 'sp-plup'), 1, 0, 0, 0, 2);
	sp_add_auth('manage_attachments', __('Can manage their uploaded attachments in profile', 'sp-plup'), 1, 1, 0, 0, 8);

    # activation so make our auth active
    sp_activate_auth('upload_images');
    sp_activate_auth('upload_media');
    sp_activate_auth('upload_files');
    sp_activate_auth('upload_signatures');
    sp_activate_auth('download_attachments');
    sp_activate_auth('manage_attachments');

	# admin task glossary entries
	include_once('sp-admin-glossary.php');
}

# sp reactivated.
function sp_plupload_do_sp_activate() {
    # add profile tabs
    sp_profile_add_tab('Attachments', 0, 1, 'manage_attachments');
    sp_profile_add_menu('Attachments', 'Image Uploads', SPPLUPFORMSDIR.'sp-plupload-images-form.php', 0, 1, 'upload_images');
    sp_profile_add_menu('Attachments', 'Media Uploads', SPPLUPFORMSDIR.'sp-plupload-media-form.php', 0, 1, 'upload_media');
    sp_profile_add_menu('Attachments', 'File Uploads', SPPLUPFORMSDIR.'sp-plupload-files-form.php', 0, 1, 'upload_files');

	# admin task glossary entries
	include_once('sp-admin-glossary.php');
}

function sp_plupload_do_reset_permissions() {
	sp_add_auth('upload_images', __('Can upload images in posts', 'sp-plup'), 1, 1, 0, 0, 8);
	sp_add_auth('upload_media', __('Can upload media in posts', 'sp-plup'), 1, 1, 0, 0, 8);
	sp_add_auth('upload_files', __('Can upload files in posts', 'sp-plup'), 1, 1, 0, 0, 8);
	sp_add_auth('upload_signatures', __('Can upload signature images', 'sp-plup'), 1, 1, 0, 0, 8);
   	sp_add_auth('download_attachments', __('Can download other file type attachments', 'sp-plup'), 1, 0, 0, 0, 2);
	sp_add_auth('manage_attachments', __('Can manage their uploaded attachments in profile', 'sp-plup'), 1, 1, 0, 0, 8);
}

?>